function getAuthorization() {
  var auth = 'Basic ' + window.btoa('integration' + ':' + 'eunGKas3Pqd6FMwx9eUpdS7xmz');
  return auth;
}

function executeGraphql(graphqlStr) {
  return new Promise(function(resolve, reject) {
    var baseUrl = window.global_wyn_baseUrl;
    fetch(baseUrl + '/connect/token', {
      method: 'POST',
      headers: {
        'Content-type': 'application/x-www-form-urlencoded',
        Authorization: getAuthorization()
      },
      body: `grant_type=password&username=${window.global_wyn_username}&password=${window.global_wyn_password}`
    })
      .then(function(res) {
        return res.json();
      })
      .then(function(res) {
        var token = res.access_token || window.global_wyn_token;
        resolve(graphqlQuery(token, graphqlStr, baseUrl));
      })
      .catch((error) => {
        handleError();
      });
  });
}

function graphqlQuery(token, graphqlStr, baseUrl) {
  return new Promise(function(resolve, reject) {
    var apiURL = baseUrl + '/api/graphql?token=' + token;
    fetch(apiURL, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        Accept: 'application/json'
      },
      mode: 'cors',
      body: JSON.stringify({
        query: graphqlStr
      })
    })
      .then(function(res) {
        if (!res.ok) {
          reject(res);
        } else {
          return res.json();
        }
      })
      .then(function(res) {
        resolve({ res, token });
      })
      .catch((error) => {
        handleError();
      });
  });
}

function handleError() {
  var loadingElement = document.getElementById('waitWrapper');
  loadingElement.style.display = 'none';
  var loadingElement = document.getElementById('container');
  container.textContent = 'Unauthorized';
}
